"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MikroFlusherContext = void 0;
const advanced_promises_1 = require("advanced-promises");
const async_hooks_1 = require("async_hooks");
/**
 * Request-scoped info for the interceptor to work.
 */
class MikroFlusherContext {
    constructor() {
        /**
         * Count of all mutations in the current request.
         */
        this.mutationCountTotal = 0;
        /**
         * Count of mutations which is already handled and waiting for flushing.
         */
        this.mutationCountHandled = 0;
        this.flush = new advanced_promises_1.Deconstructed();
    }
    static get current() {
        return this.storage.getStore();
    }
    apply(fn) {
        return MikroFlusherContext.storage.run(this, fn);
    }
}
exports.MikroFlusherContext = MikroFlusherContext;
MikroFlusherContext.storage = new async_hooks_1.AsyncLocalStorage();
//# sourceMappingURL=mikro-flusher-context.class.js.map